(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('codemirror'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('lt-codemirror', ['exports', '@angular/core', '@angular/forms', 'codemirror', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["lt-codemirror"] = {}, global.ng.core, global.ng.forms, global.codemirror, global.ng.common));
})(this, (function (exports, i0, forms, CodeMirror, common) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var CodeMirror__namespace = /*#__PURE__*/_interopNamespace(CodeMirror);

    /**
     * CodeMirror component
     * Usage :
     * <lt-codemirror [(ngModel)]="data" [config]="{...}"></lt-codemirror>
     */
    var LtCodemirrorComponent = /** @class */ (function () {
        /**
         * Constructor
         */
        function LtCodemirrorComponent() {
            // tslint:disable-next-line:no-output-native
            this.change = new i0.EventEmitter();
            // tslint:disable-next-line:no-output-native
            this.focus = new i0.EventEmitter();
            // tslint:disable-next-line:no-output-native
            this.blur = new i0.EventEmitter();
            this.cursorActivity = new i0.EventEmitter();
            this.val = '';
        }
        Object.defineProperty(LtCodemirrorComponent.prototype, "value", {
            get: function () { return this.val; },
            set: function (v) {
                if (v !== this.val) {
                    this.val = v;
                    this.onChange(v);
                }
            },
            enumerable: false,
            configurable: true
        });
        /**
         * On component destroy
         */
        LtCodemirrorComponent.prototype.ngOnDestroy = function () { };
        /**
         * On component view init
         */
        LtCodemirrorComponent.prototype.ngAfterViewInit = function () {
            this.config = this.config || {};
            this.codemirrorInit(this.config, this.size);
        };
        /**
         * Initialize codemirror
         */
        LtCodemirrorComponent.prototype.codemirrorInit = function (config, size) {
            var _this = this;
            this.instance = CodeMirror__namespace.fromTextArea(this.host.nativeElement, config);
            this.instance.setValue(this.val);
            this.instance.on('change', function () {
                _this.updateValue(_this.instance.getValue());
            });
            this.instance.on('focus', function (instance, event) {
                _this.focus.emit({ instance: instance, event: event });
            });
            this.instance.on('cursorActivity', function (instance) {
                _this.cursorActivity.emit({ instance: instance });
            });
            this.instance.on('blur', function (instance, event) {
                _this.blur.emit({ instance: instance, event: event });
            });
            if (this.size !== undefined) {
                this.instance.setSize(this.size.w, this.size.h);
            }
        };
        /**
         * Value update process
         */
        LtCodemirrorComponent.prototype.updateValue = function (value) {
            this.value = value;
            this.onTouched();
            this.change.emit(value);
        };
        /**
         * Implements ControlValueAccessor
         */
        LtCodemirrorComponent.prototype.writeValue = function (value) {
            this.val = value || '';
            if (this.instance) {
                this.instance.setValue(this.val);
            }
        };
        LtCodemirrorComponent.prototype.onChange = function (v) { };
        LtCodemirrorComponent.prototype.onTouched = function () { };
        LtCodemirrorComponent.prototype.registerOnChange = function (fn) { this.onChange = fn; };
        LtCodemirrorComponent.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        return LtCodemirrorComponent;
    }());
    LtCodemirrorComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: LtCodemirrorComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    LtCodemirrorComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: LtCodemirrorComponent, selector: "lt-codemirror", inputs: { config: "config", size: "size", value: "value" }, outputs: { change: "change", focus: "focus", blur: "blur", cursorActivity: "cursorActivity", instance: "instance" }, providers: [
            {
                provide: forms.NG_VALUE_ACCESSOR,
                useExisting: i0.forwardRef(function () { return LtCodemirrorComponent; }),
                multi: true
            }
        ], viewQueries: [{ propertyName: "host", first: true, predicate: ["host"], descendants: true }], ngImport: i0__namespace, template: "\n    <textarea #host></textarea>\n", isInline: true });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: LtCodemirrorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        // tslint:disable-next-line:component-selector
                        selector: 'lt-codemirror',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: i0.forwardRef(function () { return LtCodemirrorComponent; }),
                                multi: true
                            }
                        ],
                        template: "\n    <textarea #host></textarea>\n",
                        styles: []
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { config: [{
                    type: i0.Input
                }], size: [{
                    type: i0.Input
                }], change: [{
                    type: i0.Output
                }], focus: [{
                    type: i0.Output
                }], blur: [{
                    type: i0.Output
                }], cursorActivity: [{
                    type: i0.Output
                }], host: [{
                    type: i0.ViewChild,
                    args: ['host', { static: false }]
                }], instance: [{
                    type: i0.Output
                }], value: [{
                    type: i0.Input
                }] } });

    var LtCodemirrorModule = /** @class */ (function () {
        function LtCodemirrorModule() {
        }
        return LtCodemirrorModule;
    }());
    LtCodemirrorModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: LtCodemirrorModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    LtCodemirrorModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: LtCodemirrorModule, declarations: [LtCodemirrorComponent], imports: [common.CommonModule], exports: [LtCodemirrorComponent] });
    LtCodemirrorModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: LtCodemirrorModule, imports: [[
                common.CommonModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: LtCodemirrorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        imports: [
                            common.CommonModule
                        ],
                        declarations: [LtCodemirrorComponent],
                        exports: [LtCodemirrorComponent]
                    }]
            }] });

    /*
     * Public API Surface of lt-codemirror
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.LtCodemirrorComponent = LtCodemirrorComponent;
    exports.LtCodemirrorModule = LtCodemirrorModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lt-codemirror.umd.js.map
