import { OnDestroy, EventEmitter, AfterViewInit } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * CodeMirror component
 * Usage :
 * <lt-codemirror [(ngModel)]="data" [config]="{...}"></lt-codemirror>
 */
export declare class LtCodemirrorComponent implements AfterViewInit, OnDestroy {
    config: any;
    size: {
        w: string | number;
        h: string | number;
    } | undefined;
    change: EventEmitter<any>;
    focus: EventEmitter<any>;
    blur: EventEmitter<any>;
    cursorActivity: EventEmitter<any>;
    host: any;
    instance: any | undefined;
    val: string;
    /**
     * Constructor
     */
    constructor();
    get value(): any;
    set value(v: any);
    /**
     * On component destroy
     */
    ngOnDestroy(): void;
    /**
     * On component view init
     */
    ngAfterViewInit(): void;
    /**
     * Initialize codemirror
     */
    codemirrorInit(config: any, size: any): void;
    /**
     * Value update process
     */
    updateValue(value: any): void;
    /**
     * Implements ControlValueAccessor
     */
    writeValue(value: any): void;
    onChange(v: any): void;
    onTouched(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<LtCodemirrorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<LtCodemirrorComponent, "lt-codemirror", never, { "config": "config"; "size": "size"; "value": "value"; }, { "change": "change"; "focus": "focus"; "blur": "blur"; "cursorActivity": "cursorActivity"; "instance": "instance"; }, never, never>;
}
